import time 
import RPi.GPIO as GPIO 

GPIO.setwarnings(False) 

class keypad(): 
	def __init__(self, columnCount = 4): 
		GPIO.setmode(GPIO.BCM) 
#Tasteneinstellungen 
	if columnCount is 4: 
		self.KEYPAD = [ 
		[1,2,3,4], 
		[5,6,7,8], 
		[9,10,11,12], 
		[13,14,15,16] 
		] 
#PIN-Belegungen 
		self.ROW = [18,23,24,25] 
		self.COLUMN = [4,17,22,21] 
	else: 
		return 
 
	def getKey(self): 
		#Alle Spalten als Ausgang setzen 
		for j in range(len(self.COLUMN)): 
			GPIO.setup(self.COLUMN[j], GPIO.OUT) 
			GPIO.output(self.COLUMN[j], GPIO.LOW) 
		#Alle Reihen als Eingang setzen 
		for i in range(len(self.ROW)): 
			GPIO.setup(self.ROW[i], GPIO.IN, pull_up_down=GPIO.PUD_UP) 
		#Reihen nach gedrueckten Knoepfen scannen 
		rowVal = -1 
		for i in range(len(self.ROW)): 
			tmpRead = GPIO.input(self.ROW[i]) 
			if tmpRead == 0: 
				rowVal = i 

		if rowVal <0 or rowVal >3: 
			self.exit() 
			return 
 
		for j in range(len(self.COLUMN)): 
			GPIO.setup(self.COLUMN[j], GPIO.IN, pull_up_down=GPIO.PUD_DOWN) 
 
		GPIO.setup(self.ROW[rowVal], GPIO.OUT) 
		GPIO.output(self.ROW[rowVal], GPIO.HIGH) 
 
		colVal = -1 
		for j in range(len(self.COLUMN)): 
			tmpRead = GPIO.input(self.COLUMN[j]) 
			if tmpRead == 1: 
				colVal=j 
 
		if colVal <0 or colVal >3: 
			self.exit() 
			return 
 
#Rueckgabe der gedrueckten Taste 
		self.exit() 
		return self.KEYPAD[rowVal][colVal] 
 
	def exit(self): 
	#Neuinitialisierung aller Spalten und Reihen 
		for i in range(len(self.ROW)): 
			GPIO.setup(self.ROW[i], GPIO.IN, pull_up_down=GPIO.PUD_UP) 
		for j in range(len(self.COLUMN)): 
			GPIO.setup(self.COLUMN[j], GPIO.IN, pull_up_down=GPIO.PUD_UP) 
 
if __name__ == '__main__': 
	# Initialisierung des Tastenfelds 
	kp = keypad() 
	# Dauerschleife zur Abfrage eines Tastendrucks 
	while True: 
		digit = None 
		while digit == None: 
			digit = kp.getKey() 
		# Ausgabe des Tastendrucks 
		print digit 
		time.sleep(0.5) 

 